unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  mTGeoObj, mTGPoint, mTGLine, mTGCircle, mTGQuadrat, MathEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    BtnPointCreate: TButton;
    Label2: TLabel;
    BtnLineCreate: TButton;
    Label3: TLabel;
    BtnCircleCreate: TButton;
    Label4: TLabel;
    BtnQuadCreate: TButton;
    IntEdit1: TIntEdit;
    IntEdit2: TIntEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    IntEdit3: TIntEdit;
    Label8: TLabel;
    IntEdit4: TIntEdit;
    Label9: TLabel;
    IntEdit5: TIntEdit;
    Label10: TLabel;
    IntEdit6: TIntEdit;
    Label11: TLabel;
    IntEdit7: TIntEdit;
    Label12: TLabel;
    IntEdit8: TIntEdit;
    Label13: TLabel;
    IntEdit9: TIntEdit;
    Label14: TLabel;
    IntEdit10: TIntEdit;
    Label15: TLabel;
    IntEdit11: TIntEdit;
    Label16: TLabel;
    IntEdit12: TIntEdit;
    procedure BtnPointCreateClick(Sender: TObject);
    procedure BtnLineCreateClick(Sender: TObject);
    procedure BtnCircleCreateClick(Sender: TObject);
    procedure BtnQuadCreateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private-Deklarationen }
    GeoListe : TList;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnPointCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGPoint.Create(IntEdit1.Value, IntEdit2.Value, clBlack));
  TGeoObj(GeoListe.Last).DrawIt(PaintBox1.Canvas);
  end;

procedure TForm1.BtnLineCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGLine.Create(IntEdit3.Value, IntEdit4.Value,
                             IntEdit5.Value, IntEdit6.Value, clBlue));
  TGeoObj(GeoListe.Last).DrawIt(PaintBox1.Canvas);
  end;

procedure TForm1.BtnCircleCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGCircle.Create(IntEdit7.Value, IntEdit8.Value,
                               IntEdit9.Value, clRed));
  TGeoObj(GeoListe.Last).DrawIt(PaintBox1.Canvas);
  end;

procedure TForm1.BtnQuadCreateClick(Sender: TObject);
  begin
  GeoListe.Add(TGQuadrat.Create(IntEdit11.Value, IntEdit12.Value,
                                IntEdit10.Value, clBlue));
  TGeoObj(GeoListe.Last).DrawIt(PaintBox1.Canvas);
  end;

procedure TForm1.FormCreate(Sender: TObject);
  begin
  GeoListe := TList.Create;
  end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
  var i: Integer;
  begin
  For i := GeoListe.Count - 1 downto 0 do   // Erst alle gespeicherten
    TGeoObj(GeoListe.Items[i]).Free;        // Objekte entsorgen,
  GeoListe.Free;                            // dann die Liste selbst!
  end;

procedure TForm1.FormPaint(Sender: TObject);
  var i : Integer;
  begin
  For i := 0 to GeoListe.Count - 1 do
    TGeoObj(Geoliste.Items[i]).DrawIt(Paintbox1.Canvas);
  end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
  var d, dmin : Double;
      i       : Integer;
  begin
  dmin := 10000;
  For i := 0 to GeoListe.Count - 1 do begin
    d := TGeoObj(GeoListe.Items[i]).Dist(X, Y);
    If d < dmin then
      dmin := d;
    end;
  If dmin < 5 then
    PaintBox1.Cursor := crHandPoint
  else
    PaintBox1.Cursor := crDefault;
  end;

end.
